> ## Documentation Index
> Fetch the complete documentation index at: https://docs.neynar.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Token balance

> Fetches the token balances of a user given their FID

## Fetch User Balance

<Info>
  ### Related tutorial: [User balances directly w/ FID](/docs/how-to-fetch-user-balance-using-farcaster-fid)
</Info>

## Node.js SDK

🔗 **SDK Method:** [fetchUserBalance](/nodejs-sdk/onchain-apis/fetchUserBalance)

Use this API endpoint with the Neynar Node.js SDK for typed responses and better developer experience.


## OpenAPI

````yaml get /v2/farcaster/user/balance/
openapi: 3.0.4
info:
  contact:
    email: team@neynar.com
    name: Neynar
    url: https://neynar.com/
  description: >-
    The Neynar API allows you to interact with the Farcaster protocol among
    other things. See the [Neynar docs](https://docs.neynar.com/reference) for
    more details.
  title: Neynar API
  version: 3.173.0
servers:
  - url: https://api.neynar.com
security:
  - ApiKeyAuth: []
tags:
  - description: Operations related to user
    externalDocs:
      description: More info about user
      url: https://docs.neynar.com/reference/user-operations
    name: User
  - description: Operations related to signer
    externalDocs:
      description: More info about signer
      url: https://docs.neynar.com/reference/signer-operations
    name: Signer
  - description: Operations related to cast
    externalDocs:
      description: More info about cast
      url: https://docs.neynar.com/reference/cast-operations
    name: Cast
  - description: Operations related to feed
    externalDocs:
      description: More info about feed
      url: https://docs.neynar.com/reference/feed-operations
    name: Feed
  - description: Operations related to reaction
    externalDocs:
      description: More info about reaction
      url: https://docs.neynar.com/reference/reaction-operations
    name: Reaction
  - description: Operations related to notifications
    externalDocs:
      description: More info about notifications
      url: https://docs.neynar.com/reference/notifications-operations
    name: Notifications
  - description: Operations related to channels
    externalDocs:
      description: More info about channels
      url: https://docs.neynar.com/reference/channel-operations
    name: Channel
  - description: Operations related to follows
    externalDocs:
      description: More info about follows
      url: https://docs.neynar.com/reference/follows-operations
    name: Follows
  - description: Operations related to storage
    externalDocs:
      description: More info about storage
      url: https://docs.neynar.com/reference/storage-operations
    name: Storage
  - description: Operations related to mini apps
    name: Frame
  - description: Operations for building AI agents
    name: Agents
  - description: Operations related to fname
    name: fname
  - description: Operations related to a webhook
    name: Webhook
  - description: >-
      Securely communicate and perform actions on behalf of users across
      different apps
    externalDocs:
      description: More info about farcaster actions
      url: https://docs.neynar.com/docs/farcaster-actions-spec
    name: Action
  - description: Operations related to a subscriptions
    name: Subscribers
  - description: Operations related to a mute
    name: Mute
  - description: Operations related to a block
    name: Block
  - description: Operations related to a ban
    name: Ban
  - description: Operations related to onchain data
    name: Onchain
  - description: Operations related to login
    name: Login
  - description: Operations related to retrieving metrics
    name: Metrics
  - description: Operations related to mini app host notifications
    externalDocs:
      description: More info about mini app host notifications
      url: https://docs.neynar.com/docs/app-host-notifications
    name: App Host
paths:
  /v2/farcaster/user/balance/:
    get:
      tags:
        - Onchain
      summary: Token balance
      description: Fetches the token balances of a user given their FID
      operationId: fetch-user-balance
      parameters:
        - description: FID of the user to fetch
          in: query
          name: fid
          required: true
          schema:
            minimum: 1
            type: integer
        - description: Comma separated list of networks to fetch balances for
          in: query
          name: networks
          required: true
          schema:
            items:
              description: >-
                A blockchain network e.g. "ethereum", "optimism", "base",
                "arbitrum"
              enum:
                - ethereum
                - optimism
                - base
                - arbitrum
              title: Network
              type: string
            type: array
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/BalanceResponse'
          description: Success
        '400':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorRes'
          description: Bad Request
        '404':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorRes'
          description: Resource not found
        '500':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorRes'
          description: Server Error
      externalDocs:
        url: https://docs.neynar.com/reference/fetch-user-balance
components:
  schemas:
    BalanceResponse:
      properties:
        user_balance:
          properties:
            address_balances:
              items:
                $ref: '#/components/schemas/AddressBalance'
              type: array
            object:
              enum:
                - user_balance
              type: string
            user:
              $ref: '#/components/schemas/UserDehydrated'
          required:
            - object
            - user
            - address_balances
          type: object
      title: BalanceResponse
      type: object
    ErrorRes:
      description: Details for the error response
      properties:
        code:
          type: string
        message:
          type: string
        property:
          type: string
        status:
          format: int32
          type: integer
      required:
        - message
      title: ErrorRes
      type: object
    AddressBalance:
      description: The token balances associated with a wallet address
      properties:
        object:
          enum:
            - address_balance
          type: string
        token_balances:
          items:
            $ref: '#/components/schemas/TokenBalance'
          type: array
        verified_address:
          properties:
            address:
              description: The wallet address
              type: string
            network:
              $ref: '#/components/schemas/Network'
          required:
            - address
            - network
          type: object
      required:
        - object
        - verified_address
        - token_balances
      title: AddressBalance
      type: object
    UserDehydrated:
      properties:
        custody_address:
          $ref: '#/components/schemas/EthAddress'
        display_name:
          nullable: true
          type: string
        fid:
          $ref: '#/components/schemas/Fid'
        object:
          enum:
            - user_dehydrated
          type: string
        pfp_url:
          nullable: true
          type: string
        score:
          type: number
        username:
          type: string
      required:
        - object
        - fid
      title: UserDehydrated
      type: object
    TokenBalance:
      description: The token balance associated with a wallet address and a network
      properties:
        balance:
          properties:
            in_token:
              description: The balance in the token
              type: string
            in_usdc:
              description: The balance in USDC
              type: string
          required:
            - in_token
            - in_usdc
          type: object
        object:
          enum:
            - token_balance
          type: string
        token:
          properties:
            address:
              description: The contract address of the token (omitted for native token)
              type: string
            decimals:
              description: The number of decimals the token uses
              type: integer
            name:
              description: The token name e.g. "Ethereum"
              type: string
            object:
              enum:
                - token
              type: string
            symbol:
              description: The token symbol e.g. "ETH"
              type: string
          required:
            - object
            - name
            - symbol
          type: object
      required:
        - object
        - token
        - balance
      title: TokenBalance
      type: object
    Network:
      description: A blockchain network e.g. "ethereum", "optimism", "base", "arbitrum"
      enum:
        - ethereum
        - optimism
        - base
        - arbitrum
      title: Network
      type: string
    EthAddress:
      description: Ethereum address
      example: '0x5a927ac639636e534b678e81768ca19e2c6280b7'
      pattern: ^0x[a-fA-F0-9]{40}$
      title: EthAddress
      type: string
    Fid:
      description: The unique identifier of a farcaster user or app (unsigned integer)
      example: 3
      format: int32
      minimum: 0
      title: Fid
      type: integer
  securitySchemes:
    ApiKeyAuth:
      description: API key to authorize requests
      in: header
      name: x-api-key
      type: apiKey
      x-default: NEYNAR_API_DOCS

````